package com.muyu.server.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.common.domain.AssetAuthorization;
import com.muyu.server.mapper.AssetAuthorizationMapper;
import com.muyu.server.mapper.DataRunNameMapper;
import com.muyu.server.service.AssetAuthorizationService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Author：yang
 * @Package：com.muyu.server.service.impl
 * @Project：cloud-property
 * @name：AssetAuthorizationServiceImpl
 * @Date：2024/9/4 21:18
 */
@Service
@AllArgsConstructor
public class AssetAuthorizationServiceImpl
        extends ServiceImpl<AssetAuthorizationMapper, AssetAuthorization>
        implements AssetAuthorizationService {

    private final AssetAuthorizationMapper assetAuthorizationMapper;
    private final DataRunNameMapper dataRunNameMapper;

    /**
     * 删除用户权限方法
     * @param req 响应参数
     * @return  返回结果
     */
    @Override
    public int delUserAssetAccredit(AssetAuthorization req) {
        LambdaQueryWrapper<AssetAuthorization> queryWrapper = new LambdaQueryWrapper<>();
//        if (null==req.getBasicId()){
//            queryWrapper.eq(AssetAuthorization::getUserId,req.getUserId())
//                    .eq(AssetAuthorization::getTableId,req.getTableId());
//        }else if (null==req.getTableId()){
//            queryWrapper.eq(AssetAuthorization::getUserId,req.getUserId())
//                    .eq(AssetAuthorization::getBasicId,req.getBasicId());
//        }
        if (null==req.getUserId()) {
            return 0;
        }
            int delete = dataRunNameMapper.delUserAssetAccreditDept(req.getUserId());
            return delete;
    }

    @Override
    public int delDeptAssetAccredit(AssetAuthorization req) {
        LambdaQueryWrapper<AssetAuthorization> queryWrapper = new LambdaQueryWrapper<>();
        if (null==req.getDeptId()) {
//            queryWrapper.eq(AssetAuthorization::getDeptId,req.getDeptId())
//                    .eq(AssetAuthorization::getTableId,req.getTableId());
            return 0;
        }

            int delete = dataRunNameMapper.delDeptAssetAccredit(req.getDeptId());
            return delete;
    }

    /**
     * 查询资产赋权用户信息
     * @param req 响应参数
     * @return 返回结果
     */
    @Override
    public List<Long> findUserIdList(AssetAuthorization req) {
        List<Long> userIdList = dataRunNameMapper.findUserIdList(req);
        return userIdList;
    }

    /**
     * 查询资产赋权部门的信息
     * @param req 响应参数
     * @return 返回结果
     */
    @Override
    public List<Long> findDeptIdList(AssetAuthorization req) {
        List<Long> deptIdList = dataRunNameMapper.findDeptIdList(req);
        return deptIdList;
    }
}
